stages:
  - build
  - deploy

build-job:
  # DinD service is required for Testcontainers
  services:
    - name: docker:dind
      # explicitly disable tls to avoid docker startup interruption
      command: [ "--tls=false" ]
  variables:
    # Instruct Testcontainers to use the daemon of DinD.
    DOCKER_HOST: "tcp://docker:2375"
    # Instruct Docker not to start over TLS.
    DOCKER_TLS_CERTDIR: ""
    # Improve performance with overlayfs.
    DOCKER_DRIVER: overlay2
  before_script:
    - export GRADLE_USER_HOME=`pwd`/.gradle
  image: openjdk:17-jdk-alpine
  stage: build
  script:
    - chmod +x gradlew
    - ./gradlew
  cache:
    key: "$CI_JOB_NAME-$CI_COMMIT_REF_SLUG"
    paths:
      - .gradle/wrapper
      - .gradle/caches
      - build/**
  artifacts:
    when: always
    paths:
      - build/**
    expire_in: 1 week

docker-push-job:
  image: docker
  services:
    - docker:dind
  stage: deploy
  dependencies:
    - build-job
  variables:
    DOCKER_IMAGE: "$DOCKER_USERNAME/cinema:$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA"
  script:
    - echo $DOCKER_PASSWORD | docker login --username $DOCKER_USERNAME --password-stdin
    - docker build -t $DOCKER_IMAGE --build-arg JAR_FILE=build/libs/cinema-1.0.jar .
    - docker push $DOCKER_IMAGE
